<?php
/**
 *	All files within this package were created by David Weston,
 *	as part as the free version of antctrl.
 *
 *	This package is limited to San Andreas Multiplayer only,
 *	but it is possible to change it for other games. Feel free!
 *
 *	@package antctrl-free
 *	@version 1.1
 *	@author David Weston <westie@typefish.co.uk>
 *	@copyright 2011; http://www.typefish.co.uk/licences/
 */


$pCore->pTheme->sPageTitle = "Online server query";
$pCore->pTheme->getThemeHeader();

echo '<p><a href="'.THEME_RELDIR.'">&laquo; Back to server</a></p>';

$pServer = getRemoteConnection();
$aSettings = $pServer->getConfig();

include $sCurrent."/SampQueryAPI.php";

$query = new SampQueryAPI((defined("SERVER_IP") ? SERVER_IP : $_SERVER['SERVER_ADDR']), $aSettings['port']);


if($query->isOnline())
{
	$aInformation = $query->getInfo();	
	$aServerRules = $query->getRules();

	?>
	<b>General Information</b>
	<table width="400">
		<tr>
			<td>Hostname</td>
			<td><?php echo htmlentities($aInformation['hostname']) ?></td>
		</tr>
		<tr>
			<td>Gamemode</td>
			<td><?php echo htmlentities($aInformation['gamemode']) ?></td>
		</tr>
		<tr>
			<td>Players</td>
			<td><?php echo $aInformation['players'] ?> / <?php echo $aInformation['maxplayers'] ?></td>
		</tr>
		<tr>
			<td>Map</td>
			<td><?php echo htmlentities($aInformation['mapname']) ?></td>
		</tr>
		<tr>
			<td>Weather</td>
			<td><?php echo $aServerRules['weather'] ?></td>
		</tr>
		<tr>
			<td>Time</td>
			<td><?php echo $aServerRules['worldtime'] ?></td>
		</tr>
		<tr>
			<td>Version</td>
			<td><?php echo $aServerRules['version'] ?></td>
		</tr>
		<tr>
			<td>Password</td>
			<td><?php echo $aInformation['password'] ? 'Yes' : 'No' ?></td>
		</tr>
	</table>

	<br />
	<b>Online Players</b>
	<?php

	$aPlayers = $query->getDetailedPlayers();

	if(!is_array($aPlayers) || count($aPlayers) == 0)
	{
		echo '<br /><i>None, or unable to be deduced.</i>';
	}
	else
	{
		?>
		<table width="400">
			<tr>
				<td><b>Player ID</b></td>
				<td><b>Nickname</b></td>
				<td><b>Score</b></td>
				<td><b>Ping</b></td>
			</tr>
		<?php
		foreach($aPlayers as $sValue)
		{
			?>
			<tr>
				<td><?php echo $sValue['playerid'] ?></td>
				<td><?php echo htmlentities($sValue['nickname']) ?></td>
				<td><?php echo $sValue['score'] ?></td>
				<td><?php echo $sValue['ping'] ?></td>
			</tr>
			<?php
		}

		echo '</table>';
	}
}
else
{
	echo '<div class="Alert">The server appears to be offline!</div>';
}
	
$pCore->pTheme->getThemeFooter();